
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;

/**
 * Title:        HTMLincl
 * Description:
 * Copyright:    Copyright (c) 2001
 * @author Andreas Tetzl
 * @version 1.0
 */

public class Frame extends JFrame {
  JPanel contentPane;
  GridLayout gridLayout1 = new GridLayout();
  JPanel jPanel2 = new JPanel();
  JPanel jPanel3 = new JPanel();
  JPanel jPanel4 = new JPanel();
  JTextField jTextField_src = new JTextField();
  JButton jButton_src = new JButton();
  JTextField jTextField_dest = new JTextField();
  JButton jButton_dest = new JButton();
  JButton jButton_include = new JButton();
  JButton jButton_quit = new JButton();
  JPanel jPanel6 = new JPanel();
  JLabel jLabel2 = new JLabel();
  BorderLayout borderLayout2 = new BorderLayout();
  JPanel jPanel7 = new JPanel();
  JLabel jLabel3 = new JLabel();
  BorderLayout borderLayout3 = new BorderLayout();
  JPanel jPanel8 = new JPanel();
  BorderLayout borderLayout4 = new BorderLayout();
  JPanel jPanel1 = new JPanel();
  JLabel jLabel4 = new JLabel();
  GridLayout gridLayout2 = new GridLayout();
  JLabel jLabel_status = new JLabel();

  /**Construct the frame*/
  public Frame() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  /**Component initialization*/
  private void jbInit() throws Exception  {
    gridLayout1.setRows(3);
    gridLayout1.setColumns(2);
    //setIconImage(Toolkit.getDefaultToolkit().createImage(Frame.class.getResource("[Your Icon]")));
    contentPane = (JPanel) this.getContentPane();
    contentPane.setLayout(gridLayout1);
    this.setSize(new Dimension(300, 250));
    this.setTitle("HTML Include");
    jTextField_src.setPreferredSize(new Dimension(250, 20));
    jButton_src.setIcon(new ImageIcon(Frame.class.getResource("images/open.gif")));
    jButton_src.setMargin(new Insets(0, 0, 0, 0));
    jButton_src.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton_src_actionPerformed(e);
      }
    });
    jTextField_dest.setPreferredSize(new Dimension(250, 20));
    jButton_dest.setIcon(new ImageIcon(Frame.class.getResource("images/open.gif")));
    jButton_dest.setMargin(new Insets(0, 0, 0, 0));
    jButton_dest.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton_dest_actionPerformed(e);
      }
    });
    jButton_include.setText("Include");
    jButton_include.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton_include_actionPerformed(e);
      }
    });
    jButton_quit.setText("Quit");
    jButton_quit.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton_quit_actionPerformed(e);
      }
    });
    jLabel2.setHorizontalAlignment(SwingConstants.CENTER);
    jLabel2.setHorizontalTextPosition(SwingConstants.CENTER);
    jLabel2.setText("Source Directory");
    jLabel2.setVerticalAlignment(SwingConstants.BOTTOM);
    jLabel2.setVerticalTextPosition(SwingConstants.BOTTOM);
    jPanel2.setLayout(borderLayout2);
    jPanel3.setLayout(borderLayout3);
    jLabel3.setHorizontalAlignment(SwingConstants.CENTER);
    jLabel3.setHorizontalTextPosition(SwingConstants.CENTER);
    jLabel3.setText("Destination Directoy");
    jLabel3.setVerticalAlignment(SwingConstants.BOTTOM);
    jLabel3.setVerticalTextPosition(SwingConstants.BOTTOM);
    jPanel4.setLayout(borderLayout4);
    jLabel4.setHorizontalAlignment(SwingConstants.CENTER);
    jLabel4.setHorizontalTextPosition(SwingConstants.CENTER);
    jLabel4.setText("Copyright 2001 by Andreas Tetzl");
    jPanel1.setLayout(gridLayout2);
    gridLayout2.setRows(2);
    gridLayout2.setColumns(1);
    jLabel_status.setHorizontalAlignment(SwingConstants.CENTER);
    contentPane.add(jPanel2, null);
    jPanel2.add(jLabel2, BorderLayout.NORTH);
    jPanel2.add(jPanel6, BorderLayout.CENTER);
    jPanel6.add(jTextField_src, null);
    jPanel6.add(jButton_src, null);
    contentPane.add(jPanel3, null);
    jPanel3.add(jLabel3, BorderLayout.NORTH);
    jPanel3.add(jPanel7, BorderLayout.CENTER);
    jPanel7.add(jTextField_dest, null);
    jPanel7.add(jButton_dest, null);
    contentPane.add(jPanel4, null);
    jPanel4.add(jPanel8, BorderLayout.CENTER);
    jPanel8.add(jButton_include, null);
    jPanel8.add(jButton_quit, null);
    jPanel4.add(jPanel1, BorderLayout.SOUTH);
    jPanel1.add(jLabel_status, null);
    jPanel1.add(jLabel4, null);

    try {
      BufferedReader input = new BufferedReader(new InputStreamReader(new FileInputStream("HTMLincl.cfg")));

      String s=input.readLine();
      if (s!=null) jTextField_src.setText(s);
      s=input.readLine();
      if (s!=null) jTextField_dest.setText(s);

      input.close();
    } catch (IOException e) {
    }
  }
  /**Overridden so we can exit when window is closed*/
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      jButton_quit_actionPerformed(null);
    }
  }


  void jButton_src_actionPerformed(ActionEvent e) {
    /*
    FileDialog fileDialog = new FileDialog (this, "Choose source directory", FileDialog.LOAD);
    fileDialog.show ();
    if (fileDialog.getFile () == null)
            return;
    String fileName = fileDialog.getDirectory () + File.separator + fileDialog.getFile ();
    jTextField_src.setText(fileName);
     */

    JFileChooser chooser = new JFileChooser(jTextField_src.getText());
    //chooser.setLocale(currentLocale);
    chooser.setDialogTitle("Choose source directory");
    chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
    if (chooser.showOpenDialog(this)==JFileChooser.APPROVE_OPTION) {
      jTextField_src.setText(chooser.getSelectedFile().getAbsolutePath());
    } else return;  // FileChooser Cancel

  }

  void jButton_dest_actionPerformed(ActionEvent e) {
    JFileChooser chooser = new JFileChooser(jTextField_dest.getText());
    //chooser.setLocale(currentLocale);
    chooser.setDialogTitle("Choose destination directory");
    chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
    if (chooser.showOpenDialog(this)==JFileChooser.APPROVE_OPTION) {
      jTextField_dest.setText(chooser.getSelectedFile().getAbsolutePath());
    } else return;  // FileChooser Cancel
  }

  void jButton_include_actionPerformed(ActionEvent e) {
    String src = jTextField_src.getText();
    String dest = jTextField_dest.getText();

    int n=Include.include(src, dest);
    this.jLabel_status.setText("Processed " + n + " Files.");
  }

  void jButton_quit_actionPerformed(ActionEvent e) {
    try {
      OutputStreamWriter output = new OutputStreamWriter(new FileOutputStream("HTMLincl.cfg"));

      output.write(jTextField_src.getText() + "\n");
      output.write(jTextField_dest.getText() + "\n");
      output.close();
    } catch (IOException ex) {
    }

    System.exit(0);
  }


}