/**
 * Title:        HTMLincl
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      web-design.de
 * @author Andreas Tetzl
 * @version 1.0
 */

import java.io.*;
import java.util.*;
import java.text.SimpleDateFormat;
import org.apache.regexp.*;

public class Include {

  private Include() {
  }

  public static int include(String src, String dest) {

    File f=new File(src);
    if (!f.isDirectory()) return -1;
    return readDir(f, 0, dest, "", null);

  }


  public static int readDir(File dir, int n, String dest, String path, File templ) {
    File[] files = dir.listFiles();

    for (int i=0; i<files.length; i++) {
      //System.out.println(files[i].getName());
      if (files[i].getName().compareTo("_template.html")==0) {
        templ=files[i];
        break;
      }
    }

    String lastfile="";
    for (int i=0; i<files.length; i++) {
      File f=files[i];
      if (templ!=null && f.isFile() && f.getName().compareTo("_template.html")!=0) {
        String nextfile="";
        for (int j=i+1; j<files.length; j++) {
          if (files[j].isFile()) {
            nextfile=files[j].getName();
            break;
          }
        }
        if (include_template(f, dest, templ, path, lastfile, nextfile)) {
          n++;
          lastfile=f.getName();
        }
      } else if (f.isDirectory()) {
        String p=path;
        if (p.length()>0) p+="/";
        n=readDir(f, n, dest, p+f.getName(), templ);
      }
    }
    return n;



  }

  public static boolean include_template(File in, String out, File templ, String path, String prevfile, String nextfile) {
    System.out.println(in.getAbsolutePath());
    String slash="";
    if (path.length()>0) slash="/";
    File f=new File(out+"/"+path);
    if (f==null || !f.isDirectory())
      if (f.mkdir()==false) return false;

    out=out+"/"+path+slash+in.getName();

    
    Hashtable fields=readFields(in);
    for ( Enumeration e = fields.keys() ; e.hasMoreElements() ; ) {
       String key = (String) e.nextElement();
       System.out.println(key + "+" + fields.get(key));  
    }
    
    try {
      BufferedReader input = new BufferedReader(new InputStreamReader(new FileInputStream(templ)));
      OutputStreamWriter output = new OutputStreamWriter(new FileOutputStream(out));

      while (input.ready()) {
        int n;
        String s=input.readLine();
        if (s.toLowerCase().indexOf("</head>")>=0)
          output.write(read_head(in));

        while ((n=s.indexOf("<!--IFFILENAME"))>=0) {
          try {
            String before = s.substring(0, n);

            n+="<--IFFILENAME".length();
            String filename = new String();
            String insert = new String();
            String insertelse = new String();
            for (;s.charAt(n)!='\"';n++);
            n++;
            for (;s.charAt(n)!='\"'; n++)
              filename+=String.valueOf(s.charAt(n));
            n++;

            for (;s.charAt(n)!='\"';n++);
            n++;
            for (; s.charAt(n)!='\"' || s.charAt(n-1)=='\\'; n++)
              if (!(s.charAt(n)=='\\' && s.charAt(n+1)=='\"'))
                insert+=String.valueOf(s.charAt(n));
            n++;

            for (;s.charAt(n)!='\"' && s.charAt(n)!='>';n++);
            if (s.charAt(n)!='>') {   // ELSE Zweig vorhanden
              n++;
              for (; s.charAt(n)!='\"' || s.charAt(n-1)=='\\'; n++)
                if (!(s.charAt(n)=='\\' && s.charAt(n+1)=='\"'))
                  insertelse+=String.valueOf(s.charAt(n));
              n++;
              for (;s.charAt(n)!='>';n++);
            }
            n++;

            String after = s.substring(n);

            s=before;
            if (in.getName().indexOf(filename)>=0) {
              s+=insert;
            } else {
              s+=insertelse;
            }
            s+=after;

            /*System.out.println("\"" + in.getName() + "\"  \"" + filename + "\"");
            System.out.println(before + after);
            System.out.println(filename);
            System.out.println(insert);
            System.out.println(insertelse); */
          } catch (StringIndexOutOfBoundsException ex) {
            System.out.println("parse error in IFFILENAME");
          }
        }

        n=s.indexOf("##FILENAME##");
        if (n>=0) {
          StringTokenizer st = new StringTokenizer(s, "##FILENAME##");
          if (st.hasMoreTokens())
            s=(String)st.nextToken();

          s+=in.getName();

          if (st.hasMoreTokens())
            s+=(String)st.nextToken();
        }

        n=s.indexOf("##DATE##");
        if (n>=0) {
          StringTokenizer st = new StringTokenizer(s, "##DATE##");
          if (st.hasMoreTokens())
            s=(String)st.nextToken();

          SimpleDateFormat form = new SimpleDateFormat ("yyyy-MM-dd");
          s+=form.format(new Date());

          if (st.hasMoreTokens())
            s+=(String)st.nextToken();
        }

        for (Enumeration e = fields.keys() ; e.hasMoreElements() ; ) {
          String key = (String) e.nextElement();
          if (s.indexOf("##HTML_"+key+"##")>=0) {
            s=substitude(s, "##HTML_"+key+"##", (String)fields.get(key));
          }
        }
        
        n=s.indexOf("##CONTENT##");
        if (n>=0)
          include_file(in, output, prevfile, nextfile);
        else
          output.write(s + "\n");
      }
      output.close();
      input.close();
    } catch (IOException e) {
      return false;
    }
    return true;


  }

  public static boolean include_file(File in, OutputStreamWriter output, String prevfile, String nextfile) {
    try {
      BufferedReader input = new BufferedReader(new InputStreamReader(new FileInputStream(in)));

      String str="";
      while (input.ready()) {
        str+=input.readLine()+"\n";
      }
      input.close();
   
      
String prevpage="";
String nextpage="";
      RE re = new RE("<body.*?>|</body>");
      String[] s=re.split(str);
      str=s[1];
      if (str.indexOf("<!--IF_PREVPAGE-->")>0) {
        re=new RE("<!--IF_PREVPAGE-->|<!--/IF_PREVPAGE-->");
        s=re.split(str);
        prevpage=s[1];
        str=s[0]+"##PREVPAGE##"+(s.length>2?s[2]:"");
      }
      if (str.indexOf("<!--IF_NEXTPAGE-->")>0) {
        re=new RE("<!--IF_NEXTPAGE-->|<!--/IF_NEXTPAGE-->");
        s=re.split(str);
        nextpage=s[1];
        str=s[0]+"##NEXTPAGE##"+(s.length>2?s[2]:"");
      }
      if (prevfile.length()>0) str=substitude(str, "##PREVPAGE##", substitude(prevpage, "##PREVPAGE##", prevfile));
      if (nextfile.length()>0) str=substitude(str, "##NEXTPAGE##", substitude(nextpage, "##NEXTPAGE##", nextfile));
      str=substitude(str, "##PREVPAGE##", "");
      str=substitude(str, "##NEXTPAGE##", "");
      output.write(str);

    } catch (Exception e) {
      e.printStackTrace();
      return false;
    }
    return true;
  }


  private static String substitude(String str, String subst, String with) {
    try {
      RE re = new RE(subst);
      return re.subst(str, with, RE.REPLACE_ALL);
    } catch (Exception ex) {
      ex.printStackTrace();
      System.exit(0);
    }
    return "";
  }


  public static String read_head(File in) {
    String str=new String();

    try {
      BufferedReader input = new BufferedReader(new InputStreamReader(new FileInputStream(in)));

      boolean head=false;
      while (input.ready()) {
        String s = input.readLine();

        if (s.toLowerCase().indexOf("</head>")>=0) break;

        if (head)
          str=str + s + "\n";

        if (s.toLowerCase().indexOf("<head>")>=0) head=true;
      }
      input.close();
    } catch (IOException e) {
      return "";
    }

    return str;
  }
  
  public static Hashtable readFields(File in) {
    Hashtable fields = new Hashtable();
   
    try {
      BufferedReader input = new BufferedReader(new InputStreamReader(new FileInputStream(in)));

      String str="";
      while (input.ready()) {
        str+=input.readLine()+"\n";
      }
      input.close();     
     
      RE re2 = new RE("<!--HTML_");
      String[] s2=re2.split(str);
      for (int i=1; i<s2.length; i++) {
        String name=s2[i].substring(0, s2[i].indexOf("-->"));
        String value=s2[i].substring(s2[i].indexOf("-->")+3);
        RE re3 = new RE("<!--/HTML_"+name+"-->.*", RE.MATCH_SINGLELINE);
        value=re3.subst(value, "");
        
        //ystem.out.println("*" + name + "+" + value + "*");
        fields.put(name, value);
        
        //re3 = new RE("<!--HTML_"+name+"-->.*<!--/HTML_"+name+"-->", RE.MATCH_SINGLELINE);
        //str=re3.subst(str, "");
      }
    } catch (Exception ex) {
    }
    return fields;
  }
}

